﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace Ideia
{
    class Controller
    {
        GamePadState lastGamePadState;
        GamePadState newGamePadState;

        public Controller()
        {
            lastGamePadState = new GamePadState();
            newGamePadState = new GamePadState();
        }

        public void Update(GamePadState gamePadState)
        {
            lastGamePadState = newGamePadState;
            newGamePadState = gamePadState;
        }

        public Vector2 RightStick
        {
            get
            {
                return new Vector2(newGamePadState.ThumbSticks.Right.X,
                    newGamePadState.ThumbSticks.Right.Y);
            }
        }

        public Vector2 LeftStick
        {
            get
            {
                return new Vector2(newGamePadState.ThumbSticks.Left.X,
                    newGamePadState.ThumbSticks.Left.Y);
            }
        }

        public float LeftTrigger
        {
            get
            {
                return newGamePadState.Triggers.Left;
            }
        }

        public float RightTrigger
        {
            get
            {
                return newGamePadState.Triggers.Right;
            }
        }

        public bool ButtonIsPressed(Buttons button)
        {
            return (newGamePadState.IsButtonDown(button));
        }
        public bool ButtonIsNewPress(Buttons button)
        {
            return (newGamePadState.IsButtonDown(button) && lastGamePadState.IsButtonUp(button));
        }
    }
}
