using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Ideia
{
    public enum State
    {
        Presentation,
        MenuScreen,
        Game,
        Paused
    }
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Player player;
        bool canDo = true;

        State state = State.MenuScreen;
        Scenario back;

        SpriteFont font;

        Menu menu;
        SoundClass sClass;

        List<Human> humans;
        List<Nuvem> nuvens;
        List<Goal> goals;
        Texture2D[] texture;
        Texture2D[] goalTex;
        Texture2D cursor;
        Texture2D transTex;
        Texture2D nuvensTex;

        List<Transition> trans;

        int x = 1024;
        int y = 768;
        bool fullscreen = true;

        Input input;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = x;
            graphics.PreferredBackBufferHeight = y;

            if (fullscreen) { graphics.ToggleFullScreen(); }
        }

        protected override void Initialize()
        {
            humans = new List<Human>();
            humans.Add(new Human(new Vector2(x - 200, 200)));
            humans.Add(new Human(new Vector2(200,200)));/*
            humans.Add(new Human(new Vector2(200, y-200)));
            humans.Add(new Human(new Vector2(x-200, y-200)));
            humans.Add(new Human(new Vector2(x / 2, y / 2)));
            humans.Add(new Human(new Vector2(x / 2, 0)));
            humans.Add(new Human(new Vector2(x / 2, y)));
            humans.Add(new Human(new Vector2(0, y/2)));
            humans.Add(new Human(new Vector2(x, y/2)));*/

            trans = new List<Transition>();
            trans.Add(new Transition(humans[0]));
            trans.Add(new Transition(humans[1]));

            nuvens = new List<Nuvem>();
            nuvens.Add(new Nuvem(new Vector2(x, y)));

            MediaPlayer.IsRepeating = true;
            MediaPlayer.Play(Content.Load<Song>(@"Audio/Trilha Sonora"));

            goals = new List<Goal>();
            goals.Add(new Goal(new Vector2(x, y),47841090));
            goals.Add(new Goal(new Vector2(x, y),5078968789790));

            player = new Player();
            input = new Input();
            base.Initialize();
        }

        protected override void LoadContent()
        {
            sClass = new SoundClass(new SoundEffect[] { Content.Load<SoundEffect>(@"Audio/but"), Content.Load<SoundEffect>(@"Audio/Circ"), Content.Load<SoundEffect>(@"Audio/pdf") });

        /*
         * 0 press buto;
         * 1 circulo
         * 2 inicio
         * 3 abre P
         * 4 vento
         * 5 morre
         */ 

            spriteBatch = new SpriteBatch(GraphicsDevice);
            back = new Scenario(new Texture2D[]{Content.Load<Texture2D>(@"Scenario1"),
            Content.Load<Texture2D>(@"Scenario2"),Content.Load<Texture2D>(@"Scenario3"),
            Content.Load<Texture2D>(@"Scenario4"),Content.Load<Texture2D>(@"Scenario5")}
                ,new Vector2(x,y));
            transTex = Content.Load<Texture2D>(@"Parachute");
            menu = new Menu(Content.Load<Texture2D>(@"Splashscreen"), Content.Load<Texture2D>(@"Parachutist"), Content.Load<Texture2D>(@"ParachutistWB"), Content.Load<Texture2D>(@"Parachute"), new Vector2(x,y));
            texture = new Texture2D[]{Content.Load<Texture2D>(@"Human1"),Content.Load<Texture2D>(@"Human2")};
            font = Content.Load<SpriteFont>(@"font");
            cursor = Content.Load<Texture2D>(@"Cursor");
            nuvensTex = Content.Load<Texture2D>(@"Nuvens");
            goalTex = new Texture2D[] { Content.Load<Texture2D>(@"Goal1"), Content.Load<Texture2D>(@"Goal2") }; 
        }

        protected override void UnloadContent()
        {

        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            bool fc = false;
            bool sc = false;

            input.Update(Keyboard.GetState(), Mouse.GetState(), GamePad.GetState(PlayerIndex.One));

            if ((input.Controller.ButtonIsNewPress(Buttons.Start)) || (input.IsNewPress(Keys.Escape)))
            {
                if (state == State.Game) { state = State.Paused; }
                else if (state == State.Paused) { state = State.Game; }
            }

            if (state == State.Game)
            {
                if (back.FinishLevel)
                {
                    if (canDo) { sClass.Play(2); canDo = false; }
                    trans[0].Update(gameTime.ElapsedGameTime.TotalSeconds, new Vector2(x, y), humans[0].Position, humans[0].Rotation);
                trans[1].Update(gameTime.ElapsedGameTime.TotalSeconds, new Vector2(x, y), humans[1].Position, humans[1].Rotation);
                }
                if ((back.FinishLevel) && (trans[0].TransFinish) && (trans[1].TransFinish)) { back.PastLevel(new Vector2(x, y)); trans[0].Reset(humans[0]); trans[1].Reset(humans[1]); }
                if (goals[0].TimeHere > Goal.maxTime) goals[0].Reset(new Vector2(x, y), gameTime.TotalGameTime.TotalMilliseconds);

                player.Update(input);
                humans[0].Update(gameTime.ElapsedGameTime.TotalSeconds, player.WindForce, new Vector2(x, y));

                if (goals[0].Position != humans[0].Position)
                {
                    float catA = MathHelper.Distance(goals[0].Position.X, humans[0].Position.X);
                    float catB = MathHelper.Distance(goals[0].Position.Y, humans[0].Position.Y);
                    if ((Math.Pow(Math.Pow(catA, 2) + Math.Pow(catB, 2), ((float)1 / 2)) < 30)) { fc = true; }
                }
                else { fc = true; }

                humans[1].Update(gameTime.ElapsedGameTime.TotalSeconds, player.WindForce2, new Vector2(x, y));

                if (goals[1].Position != humans[1].Position)
                {
                    float catA = MathHelper.Distance(goals[1].Position.X, humans[1].Position.X);
                    float catB = MathHelper.Distance(goals[1].Position.Y, humans[1].Position.Y);
                    if ((Math.Pow(Math.Pow(catA, 2) + Math.Pow(catB, 2), ((float)1 / 2)) < 30)) { sc = true; }
                }
                else { sc = true; }

                if (fc && sc) { sClass.Play(1); player.AddPoints(PointsByLevel(back.Level, goals[0])); goals[0].Reset(new Vector2(x, y), gameTime.TotalGameTime.TotalMilliseconds); }
                back.Update(gameTime.ElapsedGameTime.TotalSeconds);

                foreach (Nuvem nuv in nuvens)
                {
                    nuv.Update(gameTime.ElapsedGameTime.TotalSeconds, new Vector2(x, y));
                    if (!nuv.IsActive)
                    {
                        nuv.Reset(new Vector2(x,y));
                    }
                }

                if (input.Controller.ButtonIsNewPress(Buttons.RightShoulder)) { humans[0] = new Human(new Vector2(x - 200, 200)); }
                if (input.Controller.ButtonIsNewPress(Buttons.LeftShoulder)) { humans[1] = new Human(new Vector2( 200, 200)); }

                if (goals[1].TimeHere > Goal.maxTime) goals[1].Reset(new Vector2(x, y), gameTime.TotalGameTime.TotalMilliseconds);
            }

            bool getOut = false;
            bool getIn = false;
            menu.Update(input, ref getIn, ref getOut, gameTime.ElapsedGameTime.TotalSeconds, sClass);

            if (getIn) state = State.Game;
            if (getOut) this.Exit();

            if (fc && sc) { player.AddPoints(PointsByLevel(back.Level, goals[1])); goals[1].Reset(new Vector2(x, y), gameTime.TotalGameTime.Ticks); }

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            if (state != State.MenuScreen)
            {
                back.Draw(spriteBatch, new Vector2(x, y));

                foreach (Nuvem nuv in nuvens)
                { nuv.Draw(spriteBatch, nuvensTex, Nuvem.SpriteByType(nuv.Type)); }

                spriteBatch.DrawString(font, "Points: " + player.Points, new Vector2(10, 10), Color.Yellow);

                if (back.FinishLevel) { trans[0].Draw(spriteBatch, transTex); trans[1].Draw(spriteBatch, transTex); }
                else
                {
                    goals[0].Draw(spriteBatch, goalTex[0], new Vector2(x, y), gameTime.TotalGameTime.TotalSeconds, gameTime.ElapsedGameTime.TotalSeconds);
                    goals[1].Draw(spriteBatch, goalTex[1], new Vector2(x, y), gameTime.TotalGameTime.TotalSeconds, gameTime.ElapsedGameTime.TotalSeconds);

                    humans[1].Draw(spriteBatch, texture[1]);
                    humans[0].Draw(spriteBatch, texture[0]);
                }
            }

            if (state == State.MenuScreen)
            {
                menu.Draw(spriteBatch, new Vector2(x, y), font, gameTime.TotalGameTime.TotalSeconds);
                Vector2 mouse = input.MouseXYPosition();
                spriteBatch.Draw(cursor, new Vector2(mouse.X, mouse.Y), new Rectangle(0, 0, cursor.Width, cursor.Height), Color.White,
                     Statics.AngleByMousePosition(mouse, new Vector2(graphics.PreferredBackBufferWidth, graphics.PreferredBackBufferHeight)),
                     new Vector2(22, 9), 1, SpriteEffects.None, 0);
            }

            spriteBatch.End();

            base.Draw(gameTime);
        }

        private int PointsByLevel(int Level, Goal goal)
        {
            return ((Goal.maxTime - (int)goal.TimeHere)* (Level + 5));
        }
    }
}
