﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Goal
    {
        Vector2 position;
        public Vector2 Position { get { return position; } }
        double timeHere;
        public double TimeHere { get { return timeHere; } }
        public const int maxTime = 10;

        public Goal(Vector2 Size, double time)
        {
            Reset(Size, time);
        }

        public void Reset(Vector2 Size, double time)
        {
            double a = (time % 1000) / 1000;
            double b = new Random().NextDouble();
            position = new Vector2((float)((Size.Y / 2) + (a - 0.5f) * Size.X / 2), (float)((Size.Y / 2) + ((b - 0.5f) * Size.Y / 2)));
            timeHere = 0;
        }

        public void Draw(SpriteBatch sprite, Texture2D text, Vector2 size, double time, double elapsedTime)
        {
            timeHere += elapsedTime;
            sprite.Draw(text, position, new Rectangle(0, 0, text.Width, text.Height), Color.White, (float)(time), new Vector2(text.Width / 2, text.Height / 2), 0.5f, SpriteEffects.None, 0);
        }
    }
}
