﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Human
    {
        const int fps = 20;
        const int frames = 50;
        const float airResistance = 0.04f;
        const float rotationFactor = 0.04f;

        Vector2 position;
        public Vector2 Position { get { return position; } }
        float rotation;
        public float Rotation { get { return rotation; } }
        Vector2 velocity;
        int animation;
        double animationTime;

        public Human(Vector2 Position)
        {
            position = Position;
            rotation = 0;
            animation = 0;
            animationTime = 0;
        }
        
        public void Update(double elapsedTime, Vector2 WindForce, Vector2 Size) 
        {
            animationTime += elapsedTime;
            if (animationTime > ((double)(1) / fps)) { animationTime -= (double)(1) / fps; animation++; }
            if (animation >= frames) { animation = 0; }
            velocity += WindForceByPosition( WindForce,  Size,  position);
            position += velocity;
            velocity -= airResistance * velocity;
            float wantedAngle = Statics.AngleByMousePosition(position, Size) - (float)Math.PI / 2;
            if (rotation != wantedAngle)
            {
                float neddedAngle = rotation - wantedAngle;
                if (neddedAngle < Math.PI)
                    if (neddedAngle > rotationFactor) rotation = wantedAngle;
                    else rotation += rotationFactor;
                if (neddedAngle >= Math.PI)
                    if (neddedAngle < rotationFactor) rotation = wantedAngle;
                    else rotation -= rotationFactor;
            }
        }

        private Vector2 WindForceByPosition(Vector2 WindForce, Vector2 Size, Vector2 Position) 
        {
            Vector2 retorno = new Vector2((((Position.X - Size.X / 2)) / (Size.Y * 8)), (((Position.Y - Size.Y / 2)) / (Size.Y * 8)));
            if (WindForce.X > 0)
                retorno.X = ((Size.X - Position.X) / Size.X) * WindForce.X;
            if (WindForce.X < 0)
                retorno.X = (Position.X / Size.X) * WindForce.X;

            if (WindForce.Y > 0)
                retorno.Y = ((Size.Y-Position.Y)/Size.Y)*WindForce.Y;
            if (WindForce.Y < 0)
                retorno.Y = (Position.Y/ Size.Y) * WindForce.Y;

            return retorno;
        }

        public void Draw(SpriteBatch sprite ,Texture2D HumanTexture) 
        {
            Rectangle rect = new Rectangle(128*animation,0,128,128);
            if(animation>24)
                rect = new Rectangle(128*(animation-(25)),128,128,128);
            sprite.Draw(HumanTexture, position, rect, Color.White, rotation, new Vector2(64, 64), 1, SpriteEffects.None, 0);
        }
    }
}
