﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Menu
    {
        Screen menu;
        bool credits;

        public Menu(Texture2D back, Texture2D middle, Texture2D middleWB, Texture2D parachute, Vector2 size)
        {
            string[] strs = {"JUMP","CREDITS","EXIT"};
            menu = new Screen(strs, back, middle, middleWB, parachute, size);
            credits = false;
        }

        public void Update(Input input, ref bool enterGame, ref bool getout, double elapsedTime, SoundClass sc)
        {
            menu.Update(input, elapsedTime);
            if (input.IsNewPress(Keys.Enter) || input.Controller.ButtonIsNewPress(Buttons.A) || ((input.MouseLeftButtonIsNewPress()) && menu.IsOver))
            {
                sc.Play(0);
                if (menu.Selected == 0) enterGame = true;
                else if (menu.Selected == 1)
                {
                    if (credits) credits = false; else credits = true;
                }
                else
                {
                    getout = true;
                }
            }
            if ((input.IsNewPress(Keys.Up)) || (input.Controller.ButtonIsNewPress(Buttons.DPadUp)) || (input.Controller.ButtonIsNewPress(Buttons.LeftThumbstickUp))) { menu.Change(-1); }
            if ((input.IsNewPress(Keys.Down)) || (input.Controller.ButtonIsNewPress(Buttons.DPadDown)) || (input.Controller.ButtonIsNewPress(Buttons.LeftThumbstickDown))) { menu.Change(+1); }
        }

        public void Draw(SpriteBatch sprite, Vector2 size, SpriteFont sFont, double time)
        {
            menu.Draw(sprite, size, sFont, time);
            if (credits)
            {
                string text = "Game Developed by: Bruna Lombardo,";
                Vector2 mes = sFont.MeasureString(text);
                sprite.DrawString(sFont, text, new Vector2(size.X / 2 - mes.X / 2, size.Y - 105), Color.Yellow);
                text = "Caio Cesar Lima & Yves J. Albuquerque";
                mes = sFont.MeasureString(text);
                sprite.DrawString(sFont, "Caio Cesar Lima & Yves J. Albuquerque", new Vector2(size.X/2-mes.X/2, size.Y - 55), Color.Yellow);
            }
             
        }
    }
}
