﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Nuvem
    {
        Vector2 position;
        float transparency;
        float h;
        float size;
        int type;
        bool isActive;
        public bool IsActive { get { return isActive; } }
        public int Type { get { return type; } }

        public Nuvem(Vector2 screenSize) 
        {
            Reset(screenSize);
        }

        public void Update(double elapsedTime, Vector2 screenSize) 
        {
            if (h < 15) transparency += (float)(255 * elapsedTime);
            if (size != 0) h += (float)(elapsedTime * size * 40f);
            if (h > 50) {transparency -= (float)(255 * elapsedTime);}
            if (transparency < 0) { isActive = false; }
            /*if (position.X >= (screenSize.X / 2))
                return (float)Math.Atan((position.Y - (screenSize.Y / 2)) / (position.X - (screenSize.X / 2)));
            else
                return (float)Math.Atan((position.Y - (screenSize.Y / 2)) / (position.X - (screenSize.X / 2))) + MathHelper.ToRadians(180);*/
        }

        public void Draw(SpriteBatch sprite, Texture2D text, Rectangle rect) 
        {
            sprite.Draw(text, position, rect, new Color(255, 255, 255, transparency/(float)255), 0, new Vector2(rect.Width / 2, rect.Height / 2), Scale(), SpriteEffects.None, 0);
        }

        public float Scale() { return (float)(h*size/5); }

        public static Rectangle SpriteByType(int Type) 
        {
            switch (Type)
            {
                case 0: { return new Rectangle(0, 0, 256, 170);  }
                case 1: { return new Rectangle(256, 0, 256, 170);  }
                case 2: { return new Rectangle(0, 170, 256, 170);  }
                case 3: { return new Rectangle(256, 170, 256, 170);  }
                case 4: { return new Rectangle(0, 340, 256, 170);  }
                case 5: { return new Rectangle(256, 340, 256, 170);  }
                default: { return new Rectangle(0, 0, 0, 0); }
            }
        }

        public void Reset(Vector2 screenSize)
        {
            position.X = ((float)(screenSize.X / 4) +
                new Random().Next((int)screenSize.X / 2));
            position.Y = ((float)(screenSize.Y / 4) + new Random().Next((int)screenSize.Y / 2));
            size = (float)((new Random().Next(500)) + (float)500) / (float)1000;
            type = new Random().Next(6);
            transparency = 0;
            isActive = true;
            h = 0;
        }
    }
}
