﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Scenario
    {
        Texture2D[] text;
        int level;
        public int Level { get { return level; } }
        float zoom;
        public bool FinishLevel { get { return zoom>3; } }

        public Scenario(Texture2D[] texture, Vector2 size)
        {
            zoom = 1.3f;
            level = 0;
            float propX = size.X / texture[0].Width;
            float propY = size.Y / texture[0].Height;
            if (propY > propX) zoom = propY;
            else zoom = propX;
            text = texture; 
        }

        public void Update(double elapsedTime) { if (!FinishLevel) zoom = (float)(zoom * (1 + elapsedTime * 0.02f)); }

        public void Draw(SpriteBatch sprite, Vector2 size)
        {
            sprite.Draw(text[level], new Vector2(size.X / 2, size.Y / 2), new Rectangle(0, 0, text[level].Width, text[level].Height), Color.White, 0, new Vector2(text[level].Width / 2, text[level].Height / 2), zoom, SpriteEffects.None, 0);
        }

        public void PastLevel(Vector2 size)
        {
            level++;
            float propX = size.X / text[level].Width;
            float propY = size.Y / text[level].Height;
            if (propY > propX) zoom = propY;
            else zoom = propX;
        }
    }
}
