﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Screen
    {
        Texture2D backGround;
        Texture2D middleLogo;
        Texture2D middleLogoWB;
        Texture2D parachute;

        Vector2 LogoPos;

        Color cor;

        Rectangle[] rects;

        bool isFalling;
        int h;

        bool isOver;
        public bool IsOver { get { return isOver; } }

        string[] menu;

        int selectedMenu;

        public int Selected { get { return selectedMenu; } }

        public Screen(string[] Menus, Texture2D Back, Texture2D Middle, Texture2D MiddleWB, Texture2D Parachute, Vector2 size)
        {
            LogoPos = new Vector2(size.X / 2, 0);
            h = (int)(size.Y - (Middle.Height + 30));
            isFalling = true;
            menu = Menus;
            backGround = Back;
            middleLogo = Middle;
            middleLogoWB = MiddleWB;
            parachute = Parachute;
            selectedMenu = 0;
            rects = new Rectangle[menu.Length];
            for (int i = 0; i < menu.Length; i++)
            {
                rects[i] = new Rectangle();
            }
        }

        public void Update(Input input, double elapsedTime)
        {
            if (LogoPos.Y < h)
            { LogoPos.Y += (float)(elapsedTime * 400); }
            if (LogoPos.Y > h)
            { LogoPos.Y = h; isFalling = false; }
            isOver = false;
            for (int i = 0; i < rects.Length; i++) 
            {
                if (rects[i].Contains((int)input.MouseXYPosition().X, (int)input.MouseXYPosition().Y)) { selectedMenu = i; isOver = true; }
            }
        }

        public void Draw(SpriteBatch sprite, Vector2 size, SpriteFont sFont, double time)
        {
            sprite.Draw(backGround, new Rectangle(0, 0, (int)size.X, (int)size.Y), Color.White);
            if(isFalling)sprite.Draw(middleLogoWB, LogoPos, new Rectangle(0, 0, middleLogo.Width, middleLogo.Height), Color.White, 0, new Vector2(middleLogo.Width / 2, middleLogo.Height / 2), 1, SpriteEffects.None, 0);
            else sprite.Draw(middleLogo, LogoPos, new Rectangle(0, 0, middleLogo.Width, middleLogo.Height), Color.White, 0, new Vector2(middleLogo.Width / 2, middleLogo.Height / 2), 1, SpriteEffects.None, 0);
            for (int i = 0; i < menu.Length; i++)
            {
                Vector2 mes = sFont.MeasureString(menu[i]);
                Vector2 pos = new Vector2(size.X - (mes.X + 40), 40 + (50 * i));
                rects[i] = new Rectangle((int)pos.X, (int)pos.Y, (int)mes.X, (int)mes.Y);
                Color cor = Color.White;
                float scale = 1;
                if (i == selectedMenu) { cor = new Color(new Vector4(255, 255, 0, (1 + (float)Math.Sin(time)))); scale = 0.5f + (((float)Math.Sin(time)+1)/3); }
                sprite.DrawString(sFont, menu[i], pos, cor, 0, new Vector2(0, sFont.MeasureString(menu[i]).Y/2), scale, SpriteEffects.None, 0);
            }
        }

        public void Change(int i)
        {
            selectedMenu += i;
            while (selectedMenu > (menu.Length-1)) selectedMenu -= menu.Length;
            while (selectedMenu < 0) selectedMenu += menu.Length;
        }
    }
}
