﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Ideia
{
    class Transition
    {
        const int fps = 20;
        const int frames = 6;

        bool transFinish;
        public bool TransFinish { get { return transFinish; } }

        bool begin;

        Vector2 position;
        public Vector2 Position { get { return position; } }
        float rotation;
        int animation;
        double animationTime;

        public Transition(Human hum)
        {
            Reset(hum);
        }

        public void Reset(Human hum)
        {
            position = hum.Position;
            rotation = hum.Rotation;
            transFinish = false;
            begin = false;
            animation = 0;
            animationTime = 0;
        }

        public void Begin()
        { begin = true; }

        public void Update(double elapsedTime, Vector2 Size, Vector2 Position, float Rotation)
        {
            rotation = Rotation;
            position = Position;
            animationTime += elapsedTime;
            if (animation < frames)
            {
                if (animationTime > ((double)(1) / fps)) { animationTime -= (double)(1) / fps; animation++; }
            }
            else { transFinish = true; }
        }

        public void Draw(SpriteBatch sprite, Texture2D HumanTexture)
        {
            Rectangle rect = new Rectangle(128 * animation, 0, 128, 128);
            sprite.Draw(HumanTexture, position, rect, Color.White, rotation, new Vector2(64, 64), 1, SpriteEffects.None, 0);
        }
    }
}
